<link rel="stylesheet" href="/exe//fonction.css" type="text/css" title="fonction" />

<?php
/** 
	Traitement du formulaire d'ajout d'un parcours professionnel
	auteur : Marianne JOSEPH & Romain QUELLEC
*/

/**Liste des fonctions
countPPFonction
countPPFonctionActuel
countPPFonctionActuelParSpe
countGensParEntrepriseActuel
countGensParDepartement
countGensParPays
countGensParDiplome
countGensParDiplomeIUT
countCompetences
*/

class Fonctions{
	private $objConnect;
	/*
	* Constructeur de la classe Connexion à la base
	*/
	function __construct(){
		$this->objConnect = new PDO('sqlite:/home/www-test/w_data/sqlite/bagadi.db');
	}

	/*
	* Fonction de fermeture de la connexion à la base de données
	*/
	public function disconnect(){
		$this->objConnect = null;
	}

	/*
	* Compter les metiers des parcours professionnels
	*/
	public function countPPFonction(){
	
		//Requete permettant la selection de tous les attributs de la table Fonction
		$req="SELECT * FROM Fonction;";
		//Envoie de la requete et reception de la reponse
		$res = $this->objConnect->query($req) or die ('Bad Request for countPPFonction()');
		
		//Debut du tableau
		echo '<table>';
		echo '<tr>
			<th>M&eacute;tier</th>
			<th>Sp&eacute;cialit&eacute;</th>
			<th>Quantit&eacute;</th>';
		echo '</tr>';
		//traitement de la reponse
		while ($row = $res->fetch(PDO::FETCH_NUM)) {
			//Calculer le nombre d'ancien ayant eu le metier
			$quant=$this->compter("SELECT COUNT(ancienpp) FROM ParcoursPro WHERE fonction=".$row[0].";");
			//affichage de la reponse
			echo '<tr>
				<td>'.$row[2].'</td>
				<td>'.$row[1].'</td>
				<td>'.$quant.'</td>';
			echo '</tr>';
		}
		echo '</table>';	
		
	}

	/*
	* Fonction prive permettant de compter ce que l'on veut
	*/
	private function compter($ref){
		//Recuperation de la requete
		$req=$ref;
		//Envoie de la requete et reception de la reponse
		$res=$this->objConnect->query($req) or die ('Bad Request for compter()');
		
		//Traitement de la reponse
		while ($row=$res->fetch(PDO::FETCH_NUM)) {
			$result=$row[0];
		}
		
		//Retour du resultat
		return $result;
		
	}


	/*
	* Compter les metiers qui sont les postes actuels des anciens
	*/
	public function countPPFonctionActuel(){
		//Requete permettant la selection de tous les attributs de la table Fonction
		$req='SELECT * FROM Fonction;';
		//Envoie de la requete et reception de la reponse
		$res = $this->objConnect->query($req) or die ('Bad Request for countPPFonctionActuel()');
		
		//Debut du tableau
		echo '<table>';
		echo '<tr>
			<th>M&eacute;tier</th>
			<th>Sp&eacute;cialit&eacute;</th>
			<th>Quantit&eacute;</th>';
		echo '</tr>';

		//traitement de la reponse
		while ($row = $res->fetch(PDO::FETCH_NUM)) {
			//Calculer le nombre d'ancien ayant eu le metier en cours
			$quant=$this->compter("SELECT COUNT(ancienpp) FROM ParcoursPro WHERE actuellement=1 AND fonction=".$row[0].";");
			//afficher la reponse
			echo '<tr>
				<td>'.$row[2].'</td>
				<td>'.$row[1].'</td>
				<td>'.$quant.'</td>';
			echo '</tr>';
		}
		echo '</table>';
		
	}

	/*
	* Compter le nombre actuel de parcours professionnel ayant le meme metier mais pas la meme specialite
	*/
	public function countPPFonctionActuelParMet(){
		//Requete permettant la selection de tous les metiers de la table Fonction
		$req='SELECT DISTINCT metier FROM Fonction;';
		//Envoie de la requete et reception de la reponse
		$res = $this->objConnect->query($req) or die ('Bad Request for countPPFonctionActuelParMet()');
		//Debut du Tableau	
		echo '<table>';
			echo '<tr>
				<th>M&eacute;tier</th>
				<th>Quantit&eacute;</th>';
			echo '</tr>';
		//traitement de la reponse
		while ($row = $res->fetch(PDO::FETCH_NUM)) {
			//Calculer le nombre d'ancien ayant actuellement ce metier
			$quant=$this->compter('SELECT COUNT(ancienpp) FROM ParcoursPro,Fonction WHERE actuellement=1 AND Fonction.idFonction = ParcoursPro.fonction AND metier = "'.$row[0].'";');
			//affichage de la reponse
			echo '<tr>
				<td>'.$row[0].'</td>
				<td>'.$quant.'</td>';
			echo '</tr>';
		}
		echo '</table>';
		
	}

	/*
	* Compter le nombre d'anciens travaillant dans les entreprises
	*/
	public function countGensParEntrepriseActuel(){
		//Requete permettant la selection de certains attributs de la table Entreprise
		$req='SELECT DISTINCT idEntreprise,nom,ville FROM Entreprise';
		//Envoie de la requete et reception de la reponse		
		$res = $this->objConnect->query($req) or die ('Bad Request for countGensParEntrepriseActuel()');
		//Debut du tableau
		echo '<table>';
			echo '<tr>
				<th>Nom</th>
				<th>Ville</th>
				<th>Quantit&eacute;</th>';
			echo '</tr>';
		//traitement de la reponse
		while ($row = $res->fetch(PDO::FETCH_NUM)) {
			//Calculer le nombre d'ancien etant actuellement dans l'entreprise
			$quant=$this->compter('SELECT COUNT( ancienpp ) FROM ParcoursPro WHERE actuellement=1 AND entreprise = '.$row[0].';');
			//affichage de la reponse
			echo '<tr>
				<td>'.$row[1].'</td>
				<td>'.$row[2].'</td>
				<td>'.$quant.'</td>';
			echo '</tr>';
		}
		echo '</table>';
		
	}
	

	/*
	* Compter le nombre d'anciens par departement
	*/
	public function countGensParDepartement(){
		$req='SELECT DISTINCT codePostalPerso FROM Ancien ORDER BY codePostalPerso';
		
		$res = $this->objConnect->query($req) or die ('Bad Request for countGensParDepartement()');
		
		echo '<table>';
			echo '<tr>
				<th>D&eacute;partement</th>
				<th>Quantit&eacute;</th>';
			echo '</tr>';
		while ($row = $res->fetch(PDO::FETCH_NUM)) {
			if ($row[0] != null){
				$coup=substr($row[0], 0, 2);
				$flag=true;
				if($tab!=NULL){
				foreach($tab as $i){		
					if ($i==$coup) $flag=false;
				}}
				if($flag==true) $tab[] = $coup;
			}
		}
		foreach($tab as $i){
					$quant=$this->compter('SELECT COUNT( login ) FROM Ancien WHERE codePostalPerso LIKE "'.$i.'%";');
					echo '<tr>
						<td>'.$i.'</td>
						<td>'.$quant.'</td>';
					echo '</tr>';
		}
		
		echo '</table>';
		
	}
	

	/*
	* Compter les anciens par pays
	*/
	public function countGensParPays(){

		$req='SELECT DISTINCT paysPerso FROM Ancien ORDER BY paysPerso';
		
		$res = $this->objConnect->query($req) or die ('Bad Request for countGensParPays()');
		
		echo '<table>';
		echo '<tr>
			<th>Pays</th>
			<th>Quantit&eacute;</th>';
		echo '</tr>';
			
		while ($row = $res->fetch(PDO::FETCH_NUM)) {
			if ($row[0] != null){
				$quant=$this->compter('SELECT COUNT( login ) FROM Ancien WHERE paysPerso = "'.$row[0].'";');
				echo '<tr>
					<td>'.$row[0].'</td>
					<td>'.$quant.'</td>';
				echo '</tr>';
			}
		}
		
		echo '</table>';
		
	}


	/*
	* Compter les anciens par diplome obtenu hors iut
	*/
	public function countGensParDiplome(){

		$req='SELECT DISTINCT diplome FROM AutresEtudes ORDER BY diplome';
		
		$res = $this->objConnect->query($req) or die ('Bad Request for countGensParDiplome()');
		
		echo '<table>';
		echo '<tr>
			<th>Dipl&ocirc;me</th>
			<th>Quantit&eacute;</th>';
		echo '</tr>';
		
		while ($row = $res->fetch(PDO::FETCH_NUM)) {
			$quant=$this->compter('SELECT COUNT( ancienae ) FROM EffectueAutresEtudes,AutresEtudes WHERE EffectueAutresEtudes.etudes=AutresEtudes.idEtudes AND diplome = "'.$row[0].'";');
			echo '<tr>
				<td>'.$row[0].'</td>
				<td>'.$quant.'</td>';
			echo '</tr>';
		}
		echo '</table>';
		
	}
	

	/*
	* Compter les anciens par diplome obtenu a l iut par pourcentage
	*/
	public function countGensParDiplomeIUT(){

		$req='SELECT DISTINCT nom FROM DiplomeDansIUT';
		
		$res = $this->objConnect->query($req) or die ('Bad Request for countGensParDiplomeIUT()');
		
		echo '<table>';
		echo '<tr>
			<th>Dipl&ocirc;me</th>
			<th>Quantit&eacute; %</th>';
		echo '</tr>';
			
		while ($row = $res->fetch(PDO::FETCH_NUM)) {
			$quant=$this->compterGensParDiplomeIUT($row[0]);
			echo '<tr>
				<td>'.$row[0].'</td>
				<td>'.number_format($quant).'%</td>';
			echo '</tr>';
		}
		echo '</table>';
		
	}

	/*
	* Fonction prive allant avec countGensParDiplomeIUT
	*/
	public function compterGensParDiplomeIUT($ref){

		$req='SELECT COUNT(ancienad) FROM AncienDiplome,DiplomeDansIUT WHERE AncienDiplome.diplome=DiplomeDansIUT.idDiplomedansIUT AND nom = "'.$ref.'";';
		
		$res=$this->objConnect->query($req) or die ('Bad Request for compterGensParDiplomeIUT()');
		
		while ($row=$res->fetch(PDO::FETCH_NUM)) {
			$res1=$row[0];
		}
		
		$tot=$this->totalAnciens();

		$result=$res1*100/$tot;
		
		return $result;
		
	}


	/*
	* Compter et afficher les competences sans doublon
	*/
	public function countCompetences(){
	
		$req1='SELECT DISTINCT comp1 FROM ParcoursPro;';
		$res1=$this->objConnect->query($req1) or die ('Bad Request for countCompetences() 1ere competence');
		
		echo '<table>';
		echo '<tr>
			<th>Comp&eacute;tences</th>
			<th>Quantit&eacute;</th>';
		echo '</tr>';
		while ($row1 = $res1->fetch(PDO::FETCH_NUM)) {
			if($row1[0]!=NULL){
				$quant1=$this->compterCompetences($row1[0],1);
				echo '<tr>
					<td>'.$row1[0].'</td>
					<td>'.$quant1.'</td>';
				echo '</tr>';
			}
		}
		
		$req2='SELECT DISTINCT comp2 FROM ParcoursPro;';
		$res2=$this->objConnect->query($req2) or die ('Bad Request for countCompetences() 2eme competence');
		
		while($row2=$res2->fetch(PDO::FETCH_NUM)){
			if($row2[0]!=NULL){
				$flag=true;
				$res1=$this->objConnect->query($req1) or die ('Bad Request for countCompetences() 1ere competence');
				while ($row1=$res1->fetch(PDO::FETCH_NUM)) {
					if($row1[0]==$row2[0]){
					$flag=false;			
					}
				}
				if($flag==true){
					$quant1=$this->compterCompetences($row2[0],2);
					echo '<tr>
						<td>'.$row2[0].'</td>
						<td>'.$quant1.'</td>';
					echo '</tr>';
				}
			}
		}
		
		
		$req3='SELECT DISTINCT comp3 FROM ParcoursPro;';
		$res3=$this->objConnect->query($req3) or die ('Bad Request for countCompetences() 3eme competence');
		
		while($row3=$res3->fetch(PDO::FETCH_NUM)){
			if($row3[0]!=NULL){
				$flag=true;
				$res1=$this->objConnect->query($req1) or die ('Bad Request for countCompetences() 1ere competence');
				while($row1=$res1->fetch(PDO::FETCH_NUM)){
					if($row1[0]==$row3[0]){
						$flag=false;			
					}
				}
				if($flag==true){
					$res2=$this->objConnect->query($req2) or die ('Bad Request for countCompetences() 2eme competence');
					while($row2=$res2->fetch(PDO::FETCH_NUM)){
						if($row2[0]==$row3[0]){
							$flag=false;			
						}
					}
				}
				if($flag==true){			
					$quant1=$this->compterCompetences($row3[0],3);
					echo '<tr>
						<td>'.$row3[0].'</td>
						<td>'.$quant1.'</td>';
					echo '</tr>';
				}					
			}
		}
		
		echo '</table>';
		
	}

	/*
	* Function prive allant avec CountCompetences
	*/
	private function compterCompetences($ref,$num){
		
		if($num==1 || $num==2 || $num==3){
			
			$req3='SELECT COUNT(comp3) FROM ParcoursPro WHERE comp3 = "'.$ref.'";';
			$res3=$this->objConnect->query($req3) or die ('Bad Request for compterCompetences()');
			
			while($row3=$res3->fetch(PDO::FETCH_NUM)){
				$result3=$row3[0];
			}
		}
		
		if($num==1||$num==2){
		
			$req2='SELECT COUNT(comp2) FROM ParcoursPro WHERE comp2 = "'.$ref.'";';
			$res2=$this->objConnect->query($req2) or die ('Bad Request for compterCompetences()');
			
			while($row2=$res2->fetch(PDO::FETCH_NUM)){
				$result2=$row2[0];
			}
		}

		if($num==1){
			$req1='SELECT COUNT(comp1) FROM ParcoursPro WHERE comp1 = "'.$ref.'";';
			$res1=$this->objConnect->query($req1) or die ('Bad Request for compterCompetences()');
			
			while($row1=$res1->fetch(PDO::FETCH_NUM)){
				$result1=$row1[0];
			}
		}

		if($num==1){
			$result=$result1+$result2+$result3;
		}else if($num==2){
			$result=$result3+$result2;
		}else if($num==3){
			$result=$result3;
		}

		return $result;


	}


	/*
	* Compter le nombre total d'ancien
	*/
	private function totalAnciens(){
	
		$req='SELECT COUNT(login) FROM Ancien';
		$res = $this->objConnect->query($req) or die ('Bad Request for totalAnciens()');
		while ($row=$res->fetch(PDO::FETCH_NUM)) {
			$result=$row[0];
		}
		return $result;
	}

}
?>
